-- Licensed to the public under the Apache License 2.0.

module "luci.sys.zoneinfo.tzoffset"

OFFSET = {
	gmt   =      0,	-- GMT
	eat   =  10800,	-- EAT
	cet   =   3600,	-- CET
	wat   =   3600,	-- WAT
	cat   =   7200,	-- CAT
	eet   =   7200,	-- EET
	wet   =      0,	-- WET
	sast  =   7200,	-- SAST
	hst   = -36000,	-- HST
	hdt   = -32400,	-- HDT
	akst  = -32400,	-- AKST
	akdt  = -28800,	-- AKDT
	ast   = -14400,	-- AST
	brt   = -10800,	-- BRT
	art   = -10800,	-- ART
	pyt   = -14400,	-- PYT
	pyst  = -10800,	-- PYST
	est   = -18000,	-- EST
	cst   = -21600,	-- CST
	cdt   = -18000,	-- CDT
	amt   = -14400,	-- AMT
	cot   = -18000,	-- COT
	mst   = -25200,	-- MST
	mdt   = -21600,	-- MDT
	vet   = -14400,	-- VET
	gft   = -10800,	-- GFT
	pst   = -28800,	-- PST
	pdt   = -25200,	-- PDT
	act   = -18000,	-- ACT
	wgt   = -10800,	-- WGT
	wgst  =  -7200,	-- WGST
	ect   = -18000,	-- ECT
	gyt   = -14400,	-- GYT
	bot   = -14400,	-- BOT
	pet   = -18000,	-- PET
	pmst  = -10800,	-- PMST
	pmdt  =  -7200,	-- PMDT
	uyt   = -10800,	-- UYT
	fnt   =  -7200,	-- FNT
	srt   = -10800,	-- SRT
	clt   = -14400,	-- CLT
	clst  = -10800,	-- CLST
	egt   =  -3600,	-- EGT
	egst  =      0,	-- EGST
	nst   = -12600,	-- NST
	ndt   =  -9000,	-- NDT
	mist  =  39600,	-- MIST
	nzst  =  43200,	-- NZST
	nzdt  =  46800,	-- NZDT
	ict   =  25200,	-- ICT
	bnt   =  28800,	-- BNT
	chot  =  28800,	-- CHOT
	chost =  32400,	-- CHOST
	bdt   =  21600,	-- BDT
	tlt   =  32400,	-- TLT
	gst   =  14400,	-- GST
	hkt   =  28800,	-- HKT
	hovt  =  25200,	-- HOVT
	hovst =  28800,	-- HOVST
	wib   =  25200,	-- WIB
	wit   =  32400,	-- WIT
	ist   =   7200,	-- IST
	idt   =  10800,	-- IDT
	aft   =  16200,	-- AFT
	pkt   =  18000,	-- PKT
	npt   =  20700,	-- NPT
	myt   =  28800,	-- MYT
	wita  =  28800,	-- WITA
	pht   =  28800,	-- PHT
	kst   =  30600,	-- KST
	sgt   =  28800,	-- SGT
	irst  =  12600,	-- IRST
	irdt  =  16200,	-- IRDT
	btt   =  21600,	-- BTT
	jst   =  32400,	-- JST
	ulat  =  28800,	-- ULAT
	ulast =  32400,	-- ULAST
	xjt   =  21600,	-- XJT
	mmt   =  23400,	-- MMT
	azot  =  -3600,	-- AZOT
	azost =      0,	-- AZOST
	cvt   =  -3600,	-- CVT
	fkst  = -10800,	-- FKST
	acst  =  34200,	-- ACST
	acdt  =  37800,	-- ACDT
	aest  =  36000,	-- AEST
	acwst =  31500,	-- ACWST
	lhst  =  37800,	-- LHST
	lhdt  =  39600,	-- LHDT
	awst  =  28800,	-- AWST
	msk   =  10800,	-- MSK
	iot   =  21600,	-- IOT
	cxt   =  25200,	-- CXT
	cct   =  23400,	-- CCT
	sct   =  14400,	-- SCT
	mvt   =  18000,	-- MVT
	mut   =  14400,	-- MUT
	ret   =  14400,	-- RET
	wsst  =  46800,	-- WSST
	wsdt  =  50400,	-- WSDT
	bst   =  39600,	-- BST
	chast =  45900,	-- CHAST
	chadt =  49500,	-- CHADT
	chut  =  36000,	-- CHUT
	east  = -21600,	-- EAST
	easst = -18000,	-- EASST
	vut   =  39600,	-- VUT
	phot  =  46800,	-- PHOT
	tkt   =  46800,	-- TKT
	fjt   =  43200,	-- FJT
	fjst  =  46800,	-- FJST
	tvt   =  43200,	-- TVT
	galt  = -21600,	-- GALT
	gamt  = -32400,	-- GAMT
	sbt   =  39600,	-- SBT
	lint  =  50400,	-- LINT
	kost  =  39600,	-- KOST
	mht   =  43200,	-- MHT
	mart  = -34200,	-- MART
	sst   = -39600,	-- SST
	nrt   =  43200,	-- NRT
	nut   = -39600,	-- NUT
	nft   =  39600,	-- NFT
	nct   =  39600,	-- NCT
	pwt   =  32400,	-- PWT
	pont  =  39600,	-- PONT
	pgt   =  36000,	-- PGT
	ckt   = -36000,	-- CKT
	taht  = -36000,	-- TAHT
	gilt  =  43200,	-- GILT
	wakt  =  43200,	-- WAKT
	wft   =  43200,	-- WFT
}
